/*
	Filename         : addrespwrite2.js
	Last modified by : jmueller
	Created          : 12/08/1999 13:35:05
	Last Updated     : 07/11/2000 12:08:11
	Comments         : 

	This script created by Christopher Bradford, Alive! Online.

    You may distribute this freely, but please keep the headers intact.
	
	This script requires HomeSite/CF Studio 4.

	Copyright 1999
 	Christopher Bradford
	bradford@aliveonline.com
	
	11/22/99: Modified extensively to output server-side JScript or VBScript based on @LANGUAGE tag.
		Joel Mueller
		joel@teamallaire.com
*/

// set up dictionary of precompiled Regular Expression pattern objects
function patternsDict() {
	this.quote = /\"/g;  // matches any quote
	this.openscript = /<(script)/i;  // matches any <script> tag
	this.closescript = /<\/(script)>/i;  //matches any </script> tag
	this.comment = /<!--/;  // matches any HTML open comment tag
	this.output = /<% ?=([^%]+)%>/;  // matches any ASP <%=var%> output block
	this.VBescapedQuote = /\"\"/g;  // matches a VB escaped quote: ""
	this.JSescapedQuote = /\\\"/g;  // matches a JS escaped quote: \"
	this.badChars = /([\/\\\*\[\]\?\.\(\)\+])/g;  // matches any characters that are reserved in RegEx's
	this.ASPLine = /<% ?@ ?LANGUAGE ?= ?"?(vbscript|javascript|jscript)/i; // parses the <%@LANGUAGE%> tag
}

function REFormat(string) {
	string = "" + string;
	return string.replace(patterns.badChars, "\\\$1");
}

var patterns = new patternsDict();

function Main() {
	var app = Application;
	var active = app.ActiveDocument;
	var strText = active.SelText;
	arrSelLines = strText.split("\r\n");
	var len = arrSelLines.length;
	var strTemp;
	
	// default language:
	var language = "vbscript";
	var topLine = active.Lines(0);
	// parse language out of @LANGUAGE tag in first line of file
	if (patterns.ASPLine.test(topLine)) {
		language = RegExp.$1.toLowerCase();
	}
	
	for (var count = 0; count < len; count++) {
		var curLine = arrSelLines[count];
		if (curLine.length) {
			if (language == "jscript" || language == "javascript") {
				curLine = curLine.replace(patterns.quote, "\\\"");
				curLine = curLine.replace(patterns.openscript, "<\" + \"$1");
				curLine = curLine.replace(patterns.closescript, "<\" + \"\/$1>");
				curLine = curLine.replace(patterns.comment, "<\" + \"!--");
				while (patterns.output.test(curLine)) {
					curLine = curLine.replace(patterns.output, "\" + $1 + \"");
					strTemp = RegExp.$1;
					if (strTemp.length) curLine = curLine.replace(new RegExp(REFormat(strTemp)), strTemp.replace(patterns.JSescapedQuote, "\""));
				}
				arrSelLines[count] = ((len > 2) ? "\t" : "Response.") + "Write(\"" + curLine + "\\n\");";
			} else if (language == "vbscript") {
				curLine = curLine.replace(patterns.quote, "\"\"");
				curLine = curLine.replace(patterns.openscript, "<\" & \"$1");
				curLine = curLine.replace(patterns.closescript, "<\" & \"\/$1>");
				curLine = curLine.replace(patterns.comment, "<\" & \"!--");
				while (patterns.output.test(curLine)) {
					curLine = curLine.replace(patterns.output, "\" & $1 & \"");
					strTemp = RegExp.$1;
					if (strTemp.length) curLine = curLine.replace(new RegExp(REFormat(strTemp)), strTemp.replace(patterns.VBescapedQuote, "\""));
				}
				arrSelLines[count] = ((len > 2) ? "\t." : "Response.") + "Write \"" + curLine + "\" & vbCrLf";
			}
		}
	}
	
	strText = "";
	if (len > 2) {
		if (language == "jscript" || language == "javascript") {
			strText = "with (Response) {\n";
		} else if (language == "vbscript") {
			strText = "With Response\n";
		}
	}
	strText += arrSelLines.join("\r\n");
	if (len > 2) {
		if (language == "jscript" || language == "javascript") {
			strText += "\n}";
		} else if (len > 2 && language == "vbscript") {
			strText += "\nEnd With";
		}
	}
	
	active.SelText = strText;
	
	patterns = null;
	active = null;
	app = null;
}

